﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private Polynomial					As Int		= 0xEDB88320 
	Private crc32Lookup(256)			As Int
	Private mIsInit						As Boolean	= False
	Dim nn As ByteConverter
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	ComputeLookup
	mIsInit = True
End Sub

public Sub IsInitialized() As Boolean
	Return mIsInit
End Sub

' Create the CRC32 lookup table
private Sub ComputeLookup
	Dim crc As Int
	
	For i = 0 To 255
		crc = i
		For j = 0 To 7
			crc = Bit.Xor(Bit.UnsignedShiftRight(crc, 1), Bit.And(-Bit.And(crc, 1), Polynomial))
		Next
		crc32Lookup(i) = crc
	Next
End Sub

public Sub Calc(data() As Byte) As Int
	
	Dim CRC As Int = 0
	CRC = Bit.Not(CRC)
	Dim tl1 As Int
	Dim tr1 As Int
	Dim crcRef As Int
	For length = 0 To data.Length - 1
		tl1 = Bit.And(CRC, 0xFF)
		tr1 = Bit.And(data(length), 0xFF)
		crcRef = crc32Lookup(Bit.Xor(tl1, tr1))
		CRC = Bit.Xor(Bit.UnsignedShiftRight(CRC, 8), crcRef)
	Next
	Return Bit.Not(CRC)
	
	
End Sub